Index: squid/src/mime.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/mime.c,v
retrieving revision 1.11.38.1
retrieving revision 1.11.38.2
diff -u -r1.11.38.1 -r1.11.38.2
--- squid/src/mime.c	3 Sep 2002 08:31:34 -0000	1.11.38.1
+++ squid/src/mime.c	5 Sep 2002 10:28:21 -0000	1.11.38.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: mime.c,v 1.11.38.1 2002/09/03 08:31:34 rbcollins Exp $
+ * $Id: mime.c,v 1.11.38.2 2002/09/05 10:28:21 rbcollins Exp $
  *
  * DEBUG: section 25    MIME Parsing
  * AUTHOR: Harvest Derived
@@ -34,6 +34,8 @@
  */
 
 #include "squid.h"
+#include "HttpReply.h"
+#include "HttpRequest.h"
 
 #define GET_HDR_SZ 1024
 
@@ -430,7 +432,7 @@
     storeSetPublicKey(e);
     storeBuffer(e);
     e->mem_obj->request = requestLink(urlParse(METHOD_GET, url));
-    httpReplyReset(reply = e->mem_obj->reply);
+    reply = httpReplyCreate();
     httpBuildVersion(&version, 1, 0);
     httpReplySetHeaders(reply, version, HTTP_OK, NULL,
 	type, (int) sb.st_size, sb.st_mtime, -1);
@@ -438,7 +440,6 @@
     httpHdrCcSetMaxAge(reply->cache_control, 86400);
     httpHeaderPutCc(&reply->header, reply->cache_control);
     httpReplySwapOut(reply, e);
-    reply->hdr_sz = e->mem_obj->inmem_hi;	/* yuk */
     /* read the file into the buffer and append it to store */
     buf = memAllocate(MEM_4K_BUF);
     while ((n = FD_READ_METHOD(fd, buf, 4096)) > 0)
Index: squid/src/neighbors.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/neighbors.c,v
retrieving revision 1.19
retrieving revision 1.19.2.1
diff -u -r1.19 -r1.19.2.1
--- squid/src/neighbors.c	28 Aug 2002 21:45:44 -0000	1.19
+++ squid/src/neighbors.c	5 Sep 2002 10:28:21 -0000	1.19.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: neighbors.c,v 1.19 2002/08/28 21:45:44 squidadm Exp $
+ * $Id: neighbors.c,v 1.19.2.1 2002/09/05 10:28:21 rbcollins Exp $
  *
  * DEBUG: section 15    Neighbor Routines
  * AUTHOR: Harvest Derived
@@ -34,6 +34,7 @@
  */
 
 #include "squid.h"
+#include "HttpRequest.h"
 
 /* count mcast group peers every 15 minutes */
 #define MCAST_COUNT_RATE 900
Index: squid/src/net_db.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/net_db.c,v
retrieving revision 1.15
retrieving revision 1.15.6.1
diff -u -r1.15 -r1.15.6.1
--- squid/src/net_db.c	26 Jun 2002 17:28:32 -0000	1.15
+++ squid/src/net_db.c	5 Sep 2002 10:28:21 -0000	1.15.6.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: net_db.c,v 1.15 2002/06/26 17:28:32 squidadm Exp $
+ * $Id: net_db.c,v 1.15.6.1 2002/09/05 10:28:21 rbcollins Exp $
  *
  * DEBUG: section 38    Network Measurement Database
  * AUTHOR: Duane Wessels
@@ -42,6 +42,7 @@
  */
 
 #include "squid.h"
+#include "HttpReply.h"
 
 #if USE_ICMP
 #define	NETDB_REQBUF_SZ	4096
@@ -986,7 +987,7 @@
 void
 netdbBinaryExchange(StoreEntry * s)
 {
-    http_reply *reply = s->mem_obj->reply;
+    http_reply *reply = httpReplyCreate();
     http_version_t version;
 #if USE_ICMP
     netdbEntry *n;
@@ -996,7 +997,6 @@
     char *buf;
     struct in_addr addr;
     storeBuffer(s);
-    httpReplyReset(reply);
     httpBuildVersion(&version, 1, 0);
     httpReplySetHeaders(reply, version, HTTP_OK, "OK",
 	NULL, -1, squid_curtime, -2);
@@ -1039,10 +1039,10 @@
     storeBufferFlush(s);
     memFree(buf, MEM_4K_BUF);
 #else
-    httpReplyReset(reply);
     httpBuildVersion(&version, 1, 0);
     httpReplySetHeaders(reply, version, HTTP_BAD_REQUEST, "Bad Request",
 	NULL, -1, squid_curtime, -2);
+    httpReplySwapOut(reply, s);
     storeAppendPrintf(s, "NETDB support not compiled into this Squid cache.\n");
 #endif
     storeComplete(s);
Index: squid/src/peer_select.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/peer_select.c,v
retrieving revision 1.15
retrieving revision 1.15.6.1
diff -u -r1.15 -r1.15.6.1
--- squid/src/peer_select.c	23 Jun 2002 14:57:13 -0000	1.15
+++ squid/src/peer_select.c	5 Sep 2002 10:28:22 -0000	1.15.6.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: peer_select.c,v 1.15 2002/06/23 14:57:13 squidadm Exp $
+ * $Id: peer_select.c,v 1.15.6.1 2002/09/05 10:28:22 rbcollins Exp $
  *
  * DEBUG: section 44    Peer Selection Algorithm
  * AUTHOR: Duane Wessels
@@ -34,6 +34,7 @@
  */
 
 #include "squid.h"
+#include "HttpRequest.h"
 
 const char *hier_strings[] =
 {
Index: squid/src/protos.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/protos.h,v
retrieving revision 1.59
retrieving revision 1.59.6.1
diff -u -r1.59 -r1.59.6.1
--- squid/src/protos.h	20 Jul 2002 12:33:16 -0000	1.59
+++ squid/src/protos.h	5 Sep 2002 10:28:22 -0000	1.59.6.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: protos.h,v 1.59 2002/07/20 12:33:16 squidadm Exp $
+ * $Id: protos.h,v 1.59.6.1 2002/09/05 10:28:22 rbcollins Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -125,6 +125,8 @@
 extern int cbdataReferenceValid(const void *p);
 extern cbdata_type cbdataInternalAddType(cbdata_type type, const char *label, int size, FREE * free_func);
 
+/* client_side.c - FD related client side routines */
+
 extern void clientdbInit(void);
 extern void clientdbUpdate(struct in_addr, log_type, protocol_t, size_t);
 extern int clientdbCutoffDenied(struct in_addr);
@@ -134,10 +136,8 @@
 
 extern void clientAccessCheck(void *);
 extern void clientAccessCheckDone(int, void *);
-extern int modifiedSince(StoreEntry *, request_t *);
 extern char *clientConstructTraceEcho(clientHttpRequest *);
 extern void clientPurgeRequest(clientHttpRequest *);
-extern int checkNegativeHit(StoreEntry *);
 extern void clientOpenListenSockets(void);
 extern void clientHttpConnectionsClose(void);
 extern StoreEntry *clientCreateStoreEntry(clientHttpRequest *, method_t, request_flags);
@@ -145,6 +145,19 @@
 extern void clientReadBody(request_t * req, char *buf, size_t size, CBCB * callback, void *data);
 extern int clientAbortBody(request_t * req);
 
+/* client_side_request.c - client side request related routines (pure logic) */
+extern int clientDetermineActionAfterWrite(int fd, clientHttpRequest const *http, StoreEntry *entry, size_t size);
+extern STCB clientSendMoreData;
+extern ErrorState *clientBuildError (err_type, http_status, char const *, struct in_addr *, request_t *);
+extern int clientBeginRequest (method_t, char const *, CSR *, void *, HttpHeader const *);
+
+/* client_side_reply.c - client side reply related routines (pure logic, no comms) */
+extern int clientCheckTransferDone(clientHttpRequest const *);
+
+/* clientStream.c */
+extern void clientStreamInsertHead (clientStreamNode **, CSR *, void *);
+extern clientStreamNode *clientStreamNew (CSR *, void *);
+
 extern int commSetNonBlocking(int fd);
 extern int commUnsetNonBlocking(int fd);
 extern void commSetCloseOnExec(int fd);
@@ -313,7 +326,7 @@
 extern int httpAnonHdrDenied(http_hdr_type hdr_id);
 extern void httpBuildRequestHeader(request_t *, request_t *, StoreEntry *, HttpHeader *, int, http_state_flags);
 extern void httpBuildVersion(http_version_t * version, unsigned int major, unsigned int minor);
-extern const char *httpMakeVaryMark(request_t * request, HttpReply * reply);
+extern const char *httpMakeVaryMark(request_t * request, HttpReply const * reply);
 
 /* ETag */
 extern int etagParseInit(ETag * etag, const char *str);
@@ -472,54 +485,6 @@
 extern int httpMsgIsPersistent(http_version_t http_ver, const HttpHeader * hdr);
 extern int httpMsgIsolateHeaders(const char **parse_start, const char **blk_start, const char **blk_end);
 
-/* Http Reply */
-extern void httpReplyInitModule(void);
-/* create/destroy */
-extern HttpReply *httpReplyCreate(void);
-extern void httpReplyDestroy(HttpReply * rep);
-/* reset: clean, then init */
-extern void httpReplyReset(HttpReply * rep);
-/* absorb: copy the contents of a new reply to the old one, destroy new one */
-extern void httpReplyAbsorb(HttpReply * rep, HttpReply * new_rep);
-/* parse returns -1,0,+1 on error,need-more-data,success */
-extern int httpReplyParse(HttpReply * rep, const char *buf, ssize_t);
-extern void httpReplyPackInto(const HttpReply * rep, Packer * p);
-/* ez-routines */
-/* mem-pack: returns a ready to use mem buffer with a packed reply */
-extern MemBuf httpReplyPack(const HttpReply * rep);
-/* swap: create swap-based packer, pack, destroy packer */
-extern void httpReplySwapOut(const HttpReply * rep, StoreEntry * e);
-/* set commonly used info with one call */
-extern void httpReplySetHeaders(HttpReply * rep, http_version_t ver, http_status status,
-    const char *reason, const char *ctype, int clen, time_t lmt, time_t expires);
-/* do everything in one call: init, set, pack, clean, return MemBuf */
-extern MemBuf httpPackedReply(http_version_t ver, http_status status, const char *ctype,
-    int clen, time_t lmt, time_t expires);
-/* construct 304 reply and pack it into MemBuf, return MemBuf */
-extern MemBuf httpPacked304Reply(const HttpReply * rep);
-/* update when 304 reply is received for a cached object */
-extern void httpReplyUpdateOnNotModified(HttpReply * rep, HttpReply * freshRep);
-/* header manipulation */
-extern int httpReplyContentLen(const HttpReply * rep);
-extern const char *httpReplyContentType(const HttpReply * rep);
-extern time_t httpReplyExpires(const HttpReply * rep);
-extern int httpReplyHasCc(const HttpReply * rep, http_hdr_cc_type type);
-extern void httpRedirectReply(HttpReply *, http_status, const char *);
-extern int httpReplyBodySize(method_t, HttpReply *);
-extern void httpReplyBodyBuildSize(request_t *, HttpReply *, dlink_list *);
-
-/* Http Request */
-extern request_t *requestCreate(method_t, protocol_t, const char *urlpath);
-extern void requestDestroy(request_t *);
-extern request_t *requestLink(request_t *);
-extern void requestUnlink(request_t *);
-extern int httpRequestParseHeader(request_t * req, const char *parse_start);
-extern void httpRequestSwapOut(const request_t * req, StoreEntry * e);
-extern void httpRequestPack(const request_t * req, Packer * p);
-extern int httpRequestPrefixLen(const request_t * req);
-extern int httpRequestHdrAllowed(const HttpHeaderEntry * e, String * strConnection);
-extern int httpRequestHdrAllowedByName(http_hdr_type id);
-
 extern void icmpOpen(void);
 extern void icmpClose(void);
 extern void icmpPing(struct in_addr to);
@@ -808,12 +773,10 @@
 extern void pconnHistCount(int, int);
 extern int stat5minClientRequests(void);
 extern double stat5minCPUUsage(void);
-extern const char *storeEntryFlags(const StoreEntry *);
 extern double statRequestHitRatio(int minutes);
 extern double statRequestHitMemoryRatio(int minutes);
 extern double statRequestHitDiskRatio(int minutes);
 extern double statByteHitRatio(int minutes);
-extern int storeEntryLocked(const StoreEntry *);
 
 
 /* StatHist */
@@ -899,6 +862,7 @@
 extern void storeExpireNow(StoreEntry *);
 extern void storeReleaseRequest(StoreEntry *);
 extern void storeConfigure(void);
+extern int storeCheckNegativeHit(StoreEntry *);
 extern void storeNegativeCache(StoreEntry *);
 extern void storeFreeMemory(void);
 extern int expiresMoreThan(time_t, time_t);
@@ -926,11 +890,14 @@
 extern void storeSetPrivateKey(StoreEntry *);
 extern int objectLen(const StoreEntry * e);
 extern int contentLen(const StoreEntry * e);
-extern HttpReply *storeEntryReply(StoreEntry *);
+extern HttpReply const *storeEntryReply(StoreEntry *);
 extern int storeTooManyDiskFilesOpen(void);
 extern void storeEntryReset(StoreEntry *);
 extern void storeHeapPositionUpdate(StoreEntry *, SwapDir *);
 extern void storeSwapFileNumberSet(StoreEntry * e, sfileno filn);
+extern int storeEntryLocked(const StoreEntry *);
+extern const char *storeEntryFlags(const StoreEntry *);
+extern void storeEntryReplaceObject(StoreEntry *, HttpReply *);
 extern void storeFsInit(void);
 extern void storeFsDone(void);
 extern void storeFsAdd(const char *, STSETUP *);
Index: squid/src/ssl.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ssl.c,v
retrieving revision 1.15
retrieving revision 1.15.6.1
diff -u -r1.15 -r1.15.6.1
--- squid/src/ssl.c	20 Jul 2002 12:33:16 -0000	1.15
+++ squid/src/ssl.c	5 Sep 2002 10:28:22 -0000	1.15.6.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ssl.c,v 1.15 2002/07/20 12:33:16 squidadm Exp $
+ * $Id: ssl.c,v 1.15.6.1 2002/09/05 10:28:22 rbcollins Exp $
  *
  * DEBUG: section 26    Secure Sockets Layer Proxy
  * AUTHOR: Duane Wessels
@@ -34,6 +34,7 @@
  */
 
 #include "squid.h"
+#include "HttpRequest.h"
 
 typedef struct {
     char *url;
Index: squid/src/store.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store.c,v
retrieving revision 1.17
retrieving revision 1.17.2.1
diff -u -r1.17 -r1.17.2.1
--- squid/src/store.c	15 Aug 2002 18:14:04 -0000	1.17
+++ squid/src/store.c	5 Sep 2002 10:28:22 -0000	1.17.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store.c,v 1.17 2002/08/15 18:14:04 squidadm Exp $
+ * $Id: store.c,v 1.17.2.1 2002/09/05 10:28:22 rbcollins Exp $
  *
  * DEBUG: section 20    Storage Manager
  * AUTHOR: Harvest Derived
@@ -34,6 +34,8 @@
  */
 
 #include "squid.h"
+#include "HttpReply.h"
+#include "HttpRequest.h"
 
 #define REBUILD_TIMESTAMP_DELTA_MAX 2
 
@@ -160,7 +162,7 @@
      * still have mem->clients set if mem->fd == -1
      */
     assert(mem->fd == -1 || mem->clients.head == NULL);
-    httpReplyDestroy(mem->reply);
+    httpReplyDestroy((HttpReply *)mem->reply);
     requestUnlink(mem->request);
     mem->request = NULL;
     ctx_exit(ctx);		/* must exit before we free mem->url */
@@ -428,10 +430,12 @@
 	    String vary;
 	    pe = storeCreateEntry(mem->url, mem->log_url, request->flags, request->method);
 	    httpBuildVersion(&version, 1, 0);
-	    httpReplySetHeaders(pe->mem_obj->reply, version, HTTP_OK, "Internal marker object", "x-squid-internal/vary", -1, -1, squid_curtime + 100000);
+	    /* We are allowed to do this typecast */
+	    httpReplySetHeaders((HttpReply *)pe->mem_obj->reply, version, HTTP_OK, "Internal marker object", "x-squid-internal/vary", -1, -1, squid_curtime + 100000);
 	    vary = httpHeaderGetList(&mem->reply->header, HDR_VARY);
 	    if (strBuf(vary)) {
-		httpHeaderPutStr(&pe->mem_obj->reply->header, HDR_VARY, strBuf(vary));
+		/* Again, we own this structure layout */
+		httpHeaderPutStr((HttpHeader *)&pe->mem_obj->reply->header, HDR_VARY, strBuf(vary));
 		stringClean(&vary);
 	    }
 #if X_ACCELERATOR_VARY
@@ -442,7 +446,13 @@
 	    }
 #endif
 	    storeSetPublicKey(pe);
-	    httpReplySwapOut(pe->mem_obj->reply, pe);
+	    /* TODO: remove this when the metadata is separated */
+	      {
+		Packer p;
+		packerToStoreInit(&p, pe);
+		httpReplyPackHeadersInto(pe->mem_obj->reply, &p);
+		packerClean(&p);
+	      }
 	    storeBufferFlush(pe);
 	    storeTimestampsSet(pe);
 	    storeComplete(pe);
@@ -1039,6 +1049,18 @@
     return mem->inmem_lo == 0;
 }
 
+int
+storeCheckNegativeHit(StoreEntry * e)
+{
+    if (!EBIT_TEST(e->flags, ENTRY_NEGCACHED))
+        return 0;
+    if (e->expires <= squid_curtime)
+        return 0;
+    if (e->store_status != STORE_OK)
+        return 0;
+    return 1;
+}
+
 void
 storeNegativeCache(StoreEntry * e)
 {
@@ -1263,7 +1285,7 @@
     return e->mem_obj->object_sz - e->mem_obj->reply->hdr_sz;
 }
 
-HttpReply *
+HttpReply const *
 storeEntryReply(StoreEntry * e)
 {
     if (NULL == e)
@@ -1281,11 +1303,40 @@
     assert(mem->swapout.sio == NULL);
     stmemFree(&mem->data_hdr);
     mem->inmem_hi = mem->inmem_lo = 0;
-    httpReplyDestroy(mem->reply);
-    mem->reply = httpReplyCreate();
+    /* SHould we check for clients? */
+    httpReplyReset((HttpReply *)mem->reply);
     e->expires = e->lastmod = e->timestamp = -1;
 }
 
+/* Replace a store entry with 
+ * a new reply. This eats the reply.
+ */
+void
+storeEntryReplaceObject(StoreEntry * e, HttpReply * rep)
+{
+    MemObject *mem = e->mem_obj;
+    HttpReply *myrep;
+    Packer p;
+    debug(20, 3) ("storeEntryReplaceObject: %s\n", storeUrl(e));
+    if (!mem) {
+	debug (20,0)("Attempt to replace object with no in-memory representation\n");
+	return;
+    }
+    /* TODO: check that there is at most 1 store client ? */
+    myrep = (HttpReply *)mem->reply; /* we are allowed to do this */
+    /* move info to the mem_obj->reply */
+    httpReplyAbsorb(myrep, rep);
+
+    /* TODO: when we store headers serparately remove the header portion */
+    /* TODO: mark the length of the headers ? */
+    /* We ONLY want the headers */
+    packerToStoreInit(&p, e);
+    httpReplyPackHeadersInto(mem->reply, &p);
+    myrep->hdr_sz = e->mem_obj->inmem_hi;  /* yuk */
+    httpBodyPackInto(&mem->reply->body, &p);
+    packerClean(&p);
+}
+
 /*
  * storeFsInit
  *
Index: squid/src/store_client.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_client.c,v
retrieving revision 1.13
retrieving revision 1.13.8.1
diff -u -r1.13 -r1.13.8.1
--- squid/src/store_client.c	21 Apr 2002 21:56:26 -0000	1.13
+++ squid/src/store_client.c	5 Sep 2002 10:28:22 -0000	1.13.8.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_client.c,v 1.13 2002/04/21 21:56:26 squidadm Exp $
+ * $Id: store_client.c,v 1.13.8.1 2002/09/05 10:28:22 rbcollins Exp $
  *
  * DEBUG: section 20    Storage Manager Client-Side Interface
  * AUTHOR: Duane Wessels
@@ -34,9 +34,13 @@
  */
 
 #include "squid.h"
+#include "HttpReply.h"
 
 /*
  * NOTE: 'Header' refers to the swapfile metadata header.
+ *       'OBJHeader' refers to the object header, with cannonical
+ *       processed object headers (which may derive from FTP/HTTP etc
+ *       upstream protocols/
  *       'Body' refers to the swapfile body, which is the full
  *        HTTP reply (including HTTP headers and body).
  */
@@ -369,7 +373,10 @@
     assert(sc->callback != NULL);
     debug(20, 3) ("storeClientReadBody: len %d\n", (int) len);
     if (sc->copy_offset == 0 && len > 0 && mem->reply->sline.status == 0)
-	httpReplyParse(mem->reply, sc->copy_buf, headersEnd(sc->copy_buf, len));
+	/* Our structure ! */
+	if (!httpReplyParse((HttpReply *)mem->reply, sc->copy_buf, headersEnd(sc->copy_buf, len))) {
+	    debug (20,0)("Could not parse headers from on disk object\n");
+	}
     storeClientCallback(sc, len);
 }
 
@@ -474,8 +481,11 @@
 	    (int) copy_sz);
 	xmemmove(sc->copy_buf, sc->copy_buf + swap_hdr_sz, copy_sz);
 	if (sc->copy_offset == 0 && len > 0 && mem->reply->sline.status == 0)
-	    httpReplyParse(mem->reply, sc->copy_buf,
-		headersEnd(sc->copy_buf, copy_sz));
+	    /* Our structure ! */
+	    if (!httpReplyParse((HttpReply *)mem->reply, sc->copy_buf,
+		headersEnd(sc->copy_buf, copy_sz))) {
+		debug (20,0)("could not parse headers from on disk structure!\n");
+	    }
 	storeClientCallback(sc, copy_sz);
 	return;
     }
Index: squid/src/store_log.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_log.c,v
retrieving revision 1.7
retrieving revision 1.7.38.1
diff -u -r1.7 -r1.7.38.1
--- squid/src/store_log.c	18 Oct 2001 20:52:11 -0000	1.7
+++ squid/src/store_log.c	5 Sep 2002 10:28:22 -0000	1.7.38.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_log.c,v 1.7 2001/10/18 20:52:11 squidadm Exp $
+ * $Id: store_log.c,v 1.7.38.1 2002/09/05 10:28:22 rbcollins Exp $
  *
  * DEBUG: section 20    Storage Manager Logging Functions
  * AUTHOR: Duane Wessels
@@ -50,7 +50,7 @@
 storeLog(int tag, const StoreEntry * e)
 {
     MemObject *mem = e->mem_obj;
-    HttpReply *reply;
+    HttpReply const *reply;
     if (NULL == storelog)
 	return;
 #if UNUSED_CODE
Index: squid/src/structs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/structs.h,v
retrieving revision 1.64.2.2
retrieving revision 1.64.2.3
diff -u -r1.64.2.2 -r1.64.2.3
--- squid/src/structs.h	3 Sep 2002 08:31:35 -0000	1.64.2.2
+++ squid/src/structs.h	5 Sep 2002 10:28:23 -0000	1.64.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: structs.h,v 1.64.2.2 2002/09/03 08:31:35 rbcollins Exp $
+ * $Id: structs.h,v 1.64.2.3 2002/09/05 10:28:23 rbcollins Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -1048,6 +1048,12 @@
     HierarchyLogEntry hier;
 };
 
+struct _clientStreamNode {
+    CSR *func;
+    void *data;
+    clientStreamNode *next;
+};
+
 struct _clientHttpRequest {
     ConnStateData *conn;
     request_t *request;		/* Parsed URL ... */
@@ -1091,6 +1097,7 @@
     char *reqbuf;
     int reqofs;
     int reqsize;
+    clientStreamNode *stream_head;
 };
 
 struct _ConnStateData {
@@ -1507,7 +1514,8 @@
 	mem_node *memnode;	/* which node we're currently paging out */
 	storeIOState *sio;
     } swapout;
-    HttpReply *reply;
+    /* Read only - this reply must be preserved by store clients */
+    HttpReply const *reply; /* The original reply. possibly with updated metadata. */
     request_t *request;
     struct timeval start_ping;
     IRCB *ping_reply_callback;
@@ -1623,6 +1631,7 @@
 #endif
     unsigned int accelerated:1;
     unsigned int internal:1;
+    unsigned int internalclient:1;
     unsigned int body_sent:1;
     unsigned int reset_tcp:1;
 };
Index: squid/src/typedefs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/typedefs.h,v
retrieving revision 1.27
retrieving revision 1.27.6.1
diff -u -r1.27 -r1.27.6.1
--- squid/src/typedefs.h	23 Jun 2002 13:38:04 -0000	1.27
+++ squid/src/typedefs.h	5 Sep 2002 10:28:23 -0000	1.27.6.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: typedefs.h,v 1.27 2002/06/23 13:38:04 squidadm Exp $
+ * $Id: typedefs.h,v 1.27.6.1 2002/09/05 10:28:23 rbcollins Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -31,6 +31,8 @@
  *
  */
 
+#include "squid.h"
+
 #ifndef SQUID_TYPEDEFS_H
 #define SQUID_TYPEDEFS_H
 
@@ -106,6 +108,7 @@
 typedef struct _HttpReply HttpReply;
 typedef struct _HttpStateData HttpStateData;
 typedef struct _icpUdpData icpUdpData;
+typedef struct _clientStreamNode clientStreamNode;
 typedef struct _clientHttpRequest clientHttpRequest;
 typedef struct _ConnStateData ConnStateData;
 typedef struct _ConnCloseHelperData ConnCloseHelperData;
@@ -197,6 +200,10 @@
 typedef struct _delaySpec delaySpec;
 #endif
 
+/* client_side.c callbacks and callforwards */
+/* client stream recipient */
+typedef void CSR (clientStreamNode *, clientHttpRequest *, HttpReply *, const char *, ssize_t);
+
 typedef void CWCB(int fd, char *, size_t size, int flag, void *data);
 typedef void CNCB(int fd, int status, void *);
 
Index: squid/src/url.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/url.c,v
retrieving revision 1.10
retrieving revision 1.10.2.1
diff -u -r1.10 -r1.10.2.1
--- squid/src/url.c	24 Aug 2002 02:06:24 -0000	1.10
+++ squid/src/url.c	5 Sep 2002 10:28:23 -0000	1.10.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: url.c,v 1.10 2002/08/24 02:06:24 squidadm Exp $
+ * $Id: url.c,v 1.10.2.1 2002/09/05 10:28:23 rbcollins Exp $
  *
  * DEBUG: section 23    URL Parsing
  * AUTHOR: Duane Wessels
@@ -34,6 +34,7 @@
  */
 
 #include "squid.h"
+#include "HttpRequest.h"
 
 const char *RequestMethodStr[] =
 {
Index: squid/src/wais.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/wais.c,v
retrieving revision 1.8
retrieving revision 1.8.38.1
diff -u -r1.8 -r1.8.38.1
--- squid/src/wais.c	24 Oct 2001 09:42:14 -0000	1.8
+++ squid/src/wais.c	5 Sep 2002 10:28:24 -0000	1.8.38.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: wais.c,v 1.8 2001/10/24 09:42:14 squidadm Exp $
+ * $Id: wais.c,v 1.8.38.1 2002/09/05 10:28:24 rbcollins Exp $
  *
  * DEBUG: section 24    WAIS Relay
  * AUTHOR: Harvest Derived
@@ -34,6 +34,7 @@
  */
 
 #include "squid.h"
+#include "HttpRequest.h"
 
 typedef struct {
     int fd;
Index: squid/src/whois.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/whois.c,v
retrieving revision 1.9
retrieving revision 1.9.2.1
diff -u -r1.9 -r1.9.2.1
--- squid/src/whois.c	22 Aug 2002 12:30:09 -0000	1.9
+++ squid/src/whois.c	5 Sep 2002 10:28:24 -0000	1.9.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: whois.c,v 1.9 2002/08/22 12:30:09 squidadm Exp $
+ * $Id: whois.c,v 1.9.2.1 2002/09/05 10:28:24 rbcollins Exp $
  *
  * DEBUG: section 75    WHOIS protocol
  * AUTHOR: Duane Wessels, Kostas Anagnostakis
@@ -97,8 +97,12 @@
     debug(75, 3) ("whoisReadReply: FD %d read %d bytes\n", fd, len);
     debug(75, 5) ("{%s}\n", buf);
     if (len > 0) {
-	if (0 == mem->inmem_hi)
-	    mem->reply->sline.status = HTTP_OK;
+	if (0 == mem->inmem_hi) {
+	    assert (0);
+	    /* I haven't coded for this yet. Lets see where it occurs */
+	    /* TODO: FIXME */
+	    /* ->reply->sline.status = HTTP_OK; */
+	}
 	fd_bytes(fd, len, FD_READ);
 	kb_incr(&statCounter.server.all.kbytes_in, len);
 	kb_incr(&statCounter.server.http.kbytes_in, len);
